/*
 * This file has been generated by the onto2vocabularyclass tool
 * copyright (C) 2007-2010 Sebastian Trueg <trueg@kde.org>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public License
 * along with this library; see the file COPYING.LIB.  If not, write to
 * the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301, USA.
 */

#ifndef _SOPRANO_NSO_H_
#define _SOPRANO_NSO_H_

#include <QtCore/QUrl>

namespace Nepomuk {
    namespace Vocabulary {
        namespace NSO {
            /**
             * http://www.semanticdesktop.org/ontologies/2009/11/08/nso#
             */
            QUrl nsoNamespace();

            /**
             * http://www.semanticdesktop.org/ontologies/2009/11/08/nso#
             */
            QUrl nrlOntologyGraph();

            /**
             * http://www.semanticdesktop.org/ontologies/2009/11/08/nso#sharedWithContact 
             * 
             * The subject resource is shared with the object contact. 
             * The resource and its subresources are transferred to the receiver. 
             * An existing sharedWithContact relation implies that updates 
             * on the resource should be transferred to the contact. 
             * The contact may ask for updates actively, then the sharing party's 
             * software should send a new copy of the shared resource to the 
             * contact. 
             * Domain should be either a nie:InformationElement or a pimo:Thing 
             * but no DataObject. This includes ncal:Event instances and 
             * other resources we find on a desktop. 
             * DataObjects are the specific binary stream where an Information 
             * Element is stored, and can't be shared because the recipient 
             * will form a new binary stream to store the data object. 
             * As there is no superclass of both nie:InformationElement and 
             * pimo:Thing, the domain is rdfs:Resource. 
             * One resource can be shared to multiple contacts, the cardinality 
             * is 0..n. 
             */
            QUrl sharedWithContact();

            /**
             * http://www.semanticdesktop.org/ontologies/2009/11/08/nso#sharedWithGroup 
             * 
             * The subject resource is shared with all contacts belonging 
             * to the object contact group. 
             * The resource and its subresources are transferred to the receivers. 
             * An existing sharedWithGroup relation implies that updates 
             * on the resource should be transferred to the members belonging 
             * to the group. 
             * The contact may ask for updates actively, then the sharing party's 
             * software should send a new copy of the shared resource to the 
             * contact. 
             * Domain should be either a nie:InformationElement or a pimo:Thing 
             * but no DataObject. This includes ncal:Event instances and 
             * other resources we find on a desktop. 
             * DataObjects are the specific binary stream where an Information 
             * Element is stored, and can't be shared because the recipient 
             * will form a new binary stream to store the data object. 
             * As there is no superclass of both nie:InformationElement and 
             * pimo:Thing, the domain is rdfs:Resource. 
             * One resource can be shared to multiple contact groups, the cardinality 
             * is 0..n. 
             */
            QUrl sharedWithGroup();

            /**
             * http://www.semanticdesktop.org/ontologies/2009/11/08/nso/metadata 
             */
            QUrl metadata();
        }
    }
}

#endif
