/*
 * This file is part of the Nepomuk KDE project.
 *
 * This library is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * See the file "COPYING" for the exact licensing terms.
 */

/*
 * This file has been generated by the Nepomuk Resource class generator.
 * DO NOT EDIT THIS FILE.
 * ANY CHANGES WILL BE LOST.
 */

#include <nepomuk/tools.h>
#include <nepomuk/variant.h>
#include <nepomuk/resourcemanager.h>
#include "bookmarkfolder.h"

#include "bookmark.h"
#include "bookmarkfolder.h"

#include <QtCore/QDateTime>
#include <QtCore/QDate>
#include <QtCore/QTime>


Nepomuk::BookmarkFolder::BookmarkFolder()
  : Resource( QUrl(), QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nfo#BookmarkFolder") )
{
}


Nepomuk::BookmarkFolder::BookmarkFolder( ResourceManager* manager )
  : Resource( QUrl(), QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nfo#BookmarkFolder"), manager )
{
}


Nepomuk::BookmarkFolder::BookmarkFolder( const BookmarkFolder& res )
  : Resource( res )
{
}


Nepomuk::BookmarkFolder::BookmarkFolder( const Nepomuk::Resource& res )
  : Resource( res )
{
}


Nepomuk::BookmarkFolder::BookmarkFolder( const QString& uri )
  : Resource( uri, QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nfo#BookmarkFolder") )
{
}

Nepomuk::BookmarkFolder::BookmarkFolder( const QString& uri, ResourceManager* manager )
  : Resource( uri, QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nfo#BookmarkFolder"), manager )
{
}

Nepomuk::BookmarkFolder::BookmarkFolder( const QUrl& uri )
  : Resource( uri, QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nfo#BookmarkFolder") )
{
}

Nepomuk::BookmarkFolder::BookmarkFolder( const QUrl& uri, ResourceManager* manager )
  : Resource( uri, QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nfo#BookmarkFolder"), manager )
{
}

Nepomuk::BookmarkFolder::BookmarkFolder( const QString& uri, const QUrl& type )
  : Resource( uri, type )
{
}

Nepomuk::BookmarkFolder::BookmarkFolder( const QString& uri, const QUrl& type, ResourceManager* manager )
  : Resource( uri, type, manager )
{
}

Nepomuk::BookmarkFolder::BookmarkFolder( const QUrl& uri, const QUrl& type )
  : Resource( uri, type )
{
}

Nepomuk::BookmarkFolder::BookmarkFolder( const QUrl& uri, const QUrl& type, ResourceManager* manager )
  : Resource( uri, type, manager )
{
}

Nepomuk::BookmarkFolder::~BookmarkFolder()
{
}

Nepomuk::BookmarkFolder& Nepomuk::BookmarkFolder::operator=( const BookmarkFolder& res )
{
    Resource::operator=( res );
    return *this;
}

QString Nepomuk::BookmarkFolder::resourceTypeUri()
{
    return QLatin1String("http://www.semanticdesktop.org/ontologies/2007/03/22/nfo#BookmarkFolder");
}

QList<Nepomuk::BookmarkFolder> Nepomuk::BookmarkFolder::containsBookmarkFolders() const
{
    // We always store all Resource types as plain Resource objects.
    // It does not introduce any overhead (due to the implicit sharing of
    // the data and has the advantage that we can mix setProperty calls
    // with the special Resource subclass methods.
    // More importantly Resource loads the data as Resource objects anyway.
    return convertResourceList<BookmarkFolder>( property( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nfo#containsBookmarkFolder") ).toResourceList() );
}

void Nepomuk::BookmarkFolder::setContainsBookmarkFolders( const QList<Nepomuk::BookmarkFolder>& value )
{
    // We always store all Resource types as plain Resource objects.
    // It does not introduce any overhead (due to the implicit sharing of
    // the data and has the advantage that we can mix setProperty calls
    // with the special Resource subclass methods.
    // More importantly Resource loads the data as Resource objects anyway.
    QList<Resource> l;
    for( QList<BookmarkFolder>::const_iterator it = value.constBegin();
         it != value.constEnd(); ++it ) {
        l.append( Resource( (*it) ) );
    }
    setProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nfo#containsBookmarkFolder"), Variant( l ) );
}

void Nepomuk::BookmarkFolder::addContainsBookmarkFolder( const Nepomuk::BookmarkFolder& value )
{
    // We always store all Resource types as plain Resource objects.
    // It does not introduce any overhead (due to the implicit sharing of
    // the data and has the advantage that we can mix setProperty calls
    // with the special Resource subclass methods.
    // More importantly Resource loads the data as Resource objects anyway.
    Variant v = property( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nfo#containsBookmarkFolder") );
    v.append( Resource( value ) );
    setProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nfo#containsBookmarkFolder"), v );
}

QUrl Nepomuk::BookmarkFolder::containsBookmarkFolderUri()
{
    return QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nfo#containsBookmarkFolder");
}

QList<Nepomuk::Bookmark> Nepomuk::BookmarkFolder::containsBookmarks() const
{
    // We always store all Resource types as plain Resource objects.
    // It does not introduce any overhead (due to the implicit sharing of
    // the data and has the advantage that we can mix setProperty calls
    // with the special Resource subclass methods.
    // More importantly Resource loads the data as Resource objects anyway.
    return convertResourceList<Bookmark>( property( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nfo#containsBookmark") ).toResourceList() );
}

void Nepomuk::BookmarkFolder::setContainsBookmarks( const QList<Nepomuk::Bookmark>& value )
{
    // We always store all Resource types as plain Resource objects.
    // It does not introduce any overhead (due to the implicit sharing of
    // the data and has the advantage that we can mix setProperty calls
    // with the special Resource subclass methods.
    // More importantly Resource loads the data as Resource objects anyway.
    QList<Resource> l;
    for( QList<Bookmark>::const_iterator it = value.constBegin();
         it != value.constEnd(); ++it ) {
        l.append( Resource( (*it) ) );
    }
    setProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nfo#containsBookmark"), Variant( l ) );
}

void Nepomuk::BookmarkFolder::addContainsBookmark( const Nepomuk::Bookmark& value )
{
    // We always store all Resource types as plain Resource objects.
    // It does not introduce any overhead (due to the implicit sharing of
    // the data and has the advantage that we can mix setProperty calls
    // with the special Resource subclass methods.
    // More importantly Resource loads the data as Resource objects anyway.
    Variant v = property( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nfo#containsBookmark") );
    v.append( Resource( value ) );
    setProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nfo#containsBookmark"), v );
}

QUrl Nepomuk::BookmarkFolder::containsBookmarkUri()
{
    return QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nfo#containsBookmark");
}

QList<Nepomuk::BookmarkFolder> Nepomuk::BookmarkFolder::containsBookmarkFolderOf() const
{
    return convertResourceList<BookmarkFolder>( manager()->allResourcesWithProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nfo#containsBookmarkFolder"), *this ) );
}

QList<Nepomuk::BookmarkFolder> Nepomuk::BookmarkFolder::allBookmarkFolders()
{
    return Nepomuk::convertResourceList<BookmarkFolder>( ResourceManager::instance()->allResourcesOfType( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nfo#BookmarkFolder") ) );
}


